/*--------------------------------------------------------------*
 |								|
 |	Waver  effects-file (C)GGENS (GPU) start 24.12.97	|
 |								|
 *--------------------------------------------------------------*/

void Wave::hall( int delSampl, int percent)
{
 int i, s;

 waveData1 = (short*) realloc ( waveData1, (getNumSamples()+delSampl)*2 );
 for (i=getNumSamples();i<getNumSamples()+delSampl;i++) waveData1[i]=0;
 if (getChannels()==2)
 {
  waveData2 = (short*) realloc ( waveData2, (getNumSamples()+delSampl)*2 );
  for (i=getNumSamples();i<getNumSamples()+delSampl;i++) waveData2[i]=0;
 }
 setSize( getNumSamples()*getBit()/8*getChannels() );
 setNumSamples(getNumSamples()+delSampl);
 for (i=delSampl;i<getNumSamples();i++)
 {
  s=waveData1[i]+waveData1[i-delSampl]*percent/100;
  waveData1[i]=s;
  if (getChannels()==2)
  {
   s=waveData2[i]+waveData2[i-delSampl]*percent/100;
   waveData2[i]=s;
  }
 }
 m->initPaintWave();
 m->paintWave();
}

void Wave::reverse( short *waved )
{
 short h;
 int i;

 for (i=0;i<getNumSamples()/2;i++)
 {
  h=waved[i];
  waved[i]=waved[getNumSamples()-i];
  waved[getNumSamples()-i]=h;
 }
 m->initPaintWave();
 m->paintWave();

}

void Wave::loudness( int per )
{
 int i;

 for (i=0;i<getNumSamples();i++)
 {
  waveData1[i]=waveData1[i]*per/100;
  if ( getChannels()==2) waveData2[i]=waveData2[i]*per/100;
 }
 m->initPaintWave();
 m->paintWave();
}

void Wave::invert()
{
 int i;

 for (i=0;i<getNumSamples();i++)
 {
  waveData1[i]=waveData1[i]*(-1);
  if (getChannels()==2) waveData2[i]=waveData2[i]*(-1);
 }
 m->initPaintWave();
 m->paintWave();
}

